package org.trinityhealth.example.canon;

import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.lang.reflect.InvocationTargetException;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public abstract class CanonModel {
	private ContentItem documentation;
	
	public String description() {
		StringBuffer this_serialized = new StringBuffer();
		this_serialized.append("{");
		
		BeanInfo info = null;
		try {
			info = Introspector.getBeanInfo(this.getClass(), Object.class);
		} catch (IntrospectionException e1) {
			e1.printStackTrace();
		}
		
		PropertyDescriptor[] props = info.getPropertyDescriptors();
	    for (PropertyDescriptor pd : props) {  
			try {
				if ("{".equalsIgnoreCase(this_serialized.toString())) {
					this_serialized.append("\""+pd.getName() + "\":\"" + pd.getReadMethod().invoke(this) + "\"");
				} else {
					this_serialized.append(",\""+pd.getName() + "\":\"" + pd.getReadMethod().invoke(this) + "\"");
				}
			} catch (IllegalArgumentException e) {
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				e.printStackTrace();
			}
	    }
		this_serialized.append("}");
		return this_serialized.toString();
	}

	public abstract boolean isValid();
	
	public ContentItem getDocumentation() {
		return documentation;
	}

	public void setDocumentation(ContentItem documentation) {
		this.documentation = documentation;
	};
}
