package org.trinityhealth.example.canon;

import javax.ws.rs.Consumes;

import java.util.HashMap;
import java.util.Iterator;

import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Response;

@Path("/")
public class CanonService {
	private HashMap<String, Object> canon_items = new HashMap<String, Object>();

	public CanonService() {
		canon_items.put("ContentItem", null);
		canon_items.put("Person", null);
		canon_items.put("TrinityStatus", null);
	}

    @DELETE
    @Path("/model/ContentItem")
    @Consumes("application/json")
    @Produces("application/json")
    public TrinityStatus removeContentItem() {
    	return null;
    }
    
    @DELETE
    @Path("/model/Person")
    @Consumes("application/json")
    @Produces("application/json")
    public TrinityStatus removePerson() {
    	return null;
    }
    
    @DELETE
    @Path("/model/TrinityStatus")
    @Consumes("application/json")
    @Produces("application/json")
    public TrinityStatus removeTrinityStatus() {
    	return null;
    }
    
    
    public CanonModel removeCanonItem(String canon_entity_name) {
		canon_items.remove(canon_entity_name);
		return null;
    }

    @PUT
    @Path("/model/ContentItem")
    @Consumes("application/json")
    @Produces("application/json")
    public ContentItem addContentItem(ContentItem canon_item) {
    	return null;
    }
    
    @PUT
    @Path("/model/Person")
    @Consumes("application/json")
    @Produces("application/json")
    public Person addPerson(Person canon_item) {
    	return null;
    }
    
    @PUT
    @Path("/model/TrinityStatus")
    @Consumes("application/json")
    @Produces("application/json")
    public TrinityStatus addTrinityStatus(TrinityStatus canon_item) {
    	return null;
    }
    
    public CanonModel addCanonItem(String canon_entity_name, CanonModel canon_item) {
    	CanonModel resp = getCanonItem(canon_entity_name);
    	if (TrinityStatus.class.isInstance(canon_item) && !"999".equalsIgnoreCase(((TrinityStatus)resp).getCode())) {
    		canon_items.put(canon_entity_name, null);
    	} else if (canon_item.getClass().isInstance(resp)) {
    		canon_items.put(canon_entity_name, null);
    	}
   		return resp;
    }

    @POST
    @Path("/model/ContentItem")
    @Consumes("application/json")
    @Produces("application/json")
    public ContentItem updateContentItem(ContentItem canon_item) {
    	return null;
    }
    
    @POST
    @Path("/model/Person")
    @Consumes("application/json")
    @Produces("application/json")
    public Person updatePerson(Person canon_item) {
    	return null;
    }
    
    @POST
    @Path("/model/TrinityStatus")
    @Consumes("application/json")
    @Produces("application/json")
    public TrinityStatus updateTrinityStatus(TrinityStatus canon_item) {
    	return null;
    }
    
    public CanonModel updateCanonItem(String canon_entity_name, CanonModel canon_item) {
    	return addCanonItem(canon_entity_name, canon_item);
    }

	@GET
	@Path("/model")
	@Produces("application/json")
	public HashMap<String,CanonModel> getCanon() {
		return null;
	}
	
	public Object getEntireCanon() {
		HashMap<String,CanonModel> canon = new HashMap<String,CanonModel>();
		Iterator<String> it = canon_items.keySet().iterator();
		while (it.hasNext()) {
			String key = it.next();
			try {
				canon.put(key, buildCanonItem(key));
			} catch (ClassNotFoundException e1) {
				return Response.status(Response.Status.NOT_FOUND).entity(new TrinityStatus("998", "Canon item name '"+key+"' is not found", 
						"Include a valid Canon item name in your request path, e.g. http://esb.trinityhealth.org/cxf/canon/model/Person.  For complete list of Trinity canon items see http://trinityesb/documentation", 
						new Exception().getStackTrace())).build();
			} catch (Exception e) {
				return Response.status(Response.Status.INTERNAL_SERVER_ERROR).entity(new TrinityStatus("998", "Unable to create canon object 'org.trinityhealth.example.canon."+key+"' due to '" + e.toString() + "'", 
						"Include a valid Canon item name in your request path, e.g. http://esb.trinityhealth.org/cxf/canon/model/Person.  For complete list of Trinity canon items see http://trinityesb/documentation", 
						e.getStackTrace())).build();
			}
		}
		return canon;
	}

	@GET
	@Path("/model/ContentItem")
	@Produces("application/json")
	public ContentItem getContentItem() {
		return null;
	}

	@GET
	@Path("/model/Person")
	@Produces("application/json")
	public Person getPerson() {
		return null;
	}

	@GET
	@Path("/model/TrinityStatus")
	@Produces("application/json")
	public TrinityStatus getTrinityStatus() {
		return null;
	}
	
	public CanonModel getCanonItem(String canon_entity_name) {
		if (canon_entity_name == null) {
			return new TrinityStatus("400", "Canon item name must be final path element of request", 
							"Include a valid Canon item name in your request path, e.g. http://esb.trinityhealth.org/cxf/canon/model/PERSON.  For complete list of Trinity canon items see http://trinityesb/documentation", 
							new Exception().getStackTrace());
		} else {
			try {
				return buildCanonItem(canon_entity_name); 
			} catch (ClassNotFoundException e1) {
				return new TrinityStatus("404", "Canon item name '"+canon_entity_name+"' is not found", 
						"Include a valid Canon item name in your request path, e.g. http://esb.trinityhealth.org/cxf/canon/model/Person.  For complete list of Trinity canon items see http://trinityesb/documentation", 
						new Exception().getStackTrace());
			} catch (Exception e) {
				return new TrinityStatus("500", "Unable to create canon object 'org.trinityhealth.example.canon."+canon_entity_name+"' due to '" + e.toString() + "'", 
						"Include a valid Canon item name in your request path, e.g. http://esb.trinityhealth.org/cxf/canon/model/Person.  For complete list of Trinity canon items see http://trinityesb/documentation", 
						e.getStackTrace());
			}
		}
	}

	private CanonModel buildCanonItem(String canon_entity_name) throws Exception {
		Class<?> clazz;
		clazz = Class.forName(toBus(canon_entity_name));
		return (CanonModel) clazz.getMethod("demoItem").invoke(null);
	}
	
	private String toBus(String canon_entity_name) throws Exception {
		return "org.trinityhealth.example.canon." + canon_entity_name;
	}	
}
