package org.trinityhealth.example.canon;

import java.util.ArrayList;
import java.util.Random;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class Person extends CanonModel {
    private String user_id;
	private boolean authenticated;
    private ArrayList<String> member_of;
    private ArrayList<String> attributes;

	private static String[] last_names = {"Smith","Jones","Wilson","Andrews"};
	private static String[] first_names = {"Harry","Ronald","Belinda","Samantha"};
	private static String[] groups = {"FH01 Domain Users","NODC Enterprise Web Development","NODC Intranet Consolidation Admins","NODC Enterprise Web Admins"};
	private static String[] attribs = {"oncall","inameeting","online","offsite"};
	private static Random rand = new Random();
	
    public Person() {
		super();
    	member_of = new ArrayList<String>();
    	attributes = new ArrayList<String>();
    }
    
    public Person(String user_id, boolean authenticated, ArrayList<String> member_of, ArrayList<String> attributes) {
		super();
		this.user_id = user_id;
		this.authenticated = authenticated;
		this.member_of = member_of;
		this.attributes = attributes;
	}
    
    public static Person demoItem() {
    	Person this_user = new Person();
    	this_user.user_id = last_names[rand.nextInt(last_names.length)].toLowerCase() + 
    						first_names[rand.nextInt(first_names.length)].toLowerCase().substring(0, 1);
    	this_user.authenticated = rand.nextBoolean();
    	this_user.member_of = new ArrayList<String>();
    	for (int i = 0; i < groups.length; i++) {
    		if (rand.nextBoolean()) this_user.member_of.add(groups[i]);
		}
    	this_user.attributes = new ArrayList<String>();
    	for (int i = 0; i < attribs.length; i++) {
    		if (rand.nextBoolean()) this_user.attributes.add(attribs[i]);
		}
    	this_user.setDocumentation(new ContentItem("Person Documentation","007","Scott Cornell","01/01/2000","ECM","view","http://intranet.trinity-health.org/",
    								new ContentItem("ContentItem Documentation","NCC1701","Scott Cornell","01/01/2000","ECM","view","http://ecm.trinity-health.org",null)));
    	return this_user;
    }
    
	@Override
	public boolean isValid() {
		if (this.user_id == null || this.user_id == "") return false;
		if (this.getDocumentation() == null || !this.getDocumentation().isValid()) return false;
		return true;
	}
	
	public static void main(String[] args) {
		if (Person.demoItem().isValid()) System.out.println("OK");;
	}
	
	public String getUser_id() {
		return user_id;
	}
	public void setUser_id(String user_id) {
		this.user_id = user_id;
	}
	public boolean isAuthenticated() {
		return authenticated;
	}
	public void setAuthenticated(boolean authenticated) {
		this.authenticated = authenticated;
	}
	public ArrayList<String> getMember_of() {
		return member_of;
	}
	public void setMember_of(ArrayList<String> member_of) {
		this.member_of = member_of;
	}
	public ArrayList<String> getAttributes() {
		return attributes;
	}
	public void setAttributes(ArrayList<String> attributes) {
		this.attributes = attributes;
	}
}
