package org.trinityhealth.example.canon;

import java.util.Random;

import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class TrinityStatus extends CanonModel {

	private String code;
	private String text;
	private String suggestion;
	private String[] stack;

	private static String[] codes = {"-1","666","3.14159"};
	private static String[] texts = {"Oooh, that's gonna leave a mark!","These are not the droids you're looking for.","You have chosen ... poorly.","Cap'n, me engines canna take it no more!"};
	private static String[] suggestions = {"Try searching by last name","Did you mean /trinitygoodservice?","check at http://somewhere/canon/model for a complete list of services"};
	private static String[] stack_elements = {"DummyClass","TestClass","PrototypeClass","MockClass"};
	private static Random rand = new Random();
	
	public TrinityStatus() {
		super();
		stack = new String[0];
	}
	
	public TrinityStatus(String code, String text, String suggestion, StackTraceElement[] stack) {
		super();
		this.code = code;
		this.text = text;
		this.suggestion = suggestion;
		if (stack != null) {
			this.stack = new String[stack.length];
			for (int i = 0; i < stack.length; i++) {
				this.stack[i] = stack[i].toString();
			}
		}
	}

    public static TrinityStatus demoItem() {
    	TrinityStatus this_status = new TrinityStatus();
    	this_status.code = codes[rand.nextInt(codes.length)];
    	this_status.text = texts[rand.nextInt(texts.length)];
    	this_status.suggestion = suggestions[rand.nextInt(suggestions.length)];
		this_status.stack = new String[rand.nextInt(10)];
		for (int i = 0; i < this_status.stack.length; i++) {
			this_status.stack[i] = new StackTraceElement(
					"org.trinityhealth.example" + (rand.nextBoolean()?"instance":"") 
					+ stack_elements[rand.nextInt(stack_elements.length)], 
					"method"+i, null, rand.nextInt(200) + 50)
					.toString();
		}
		this_status.setDocumentation(new ContentItem("TrinityStatus Documentation","SG1","Scott Cornell","01/01/2000","Sharepoint","view","http://portal.che.org/Pages/Default.aspx",
									new ContentItem("ContentItem Documentation","NCC1701","Scott Cornell","01/01/2000","ECM","view","http://ecm.trinity-health.org",null)));
		return this_status;
    }
    
	@Override
	public boolean isValid() {
		if (code == null || code == "") return false;
		if (text == null || text == "") return false;
		if (suggestion == null || suggestion == "") return false;
		if (stack == null) return false;
		if (this.getDocumentation() == null || !this.getDocumentation().isValid()) return false;
		return true;
	}


	public String getCode() {
		return code;
	}


	public void setCode(String code) {
		this.code = code;
	}


	public String getText() {
		return text;
	}


	public void setText(String text) {
		this.text = text;
	}


	public String getSuggestion() {
		return suggestion;
	}


	public void setSuggestion(String suggestion) {
		this.suggestion = suggestion;
	}


	public String[] getStack() {
		return stack;
	}


	public void setStack(String[] stack) {
		this.stack = stack;
	}
}
